commit 3bac7a1bac4fbccea548b3f8ed9a788b8b41d943
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Mon Nov 10 10:09:49 2025 +0000

    Fix CYRUS_SASLAUTHD_SOCKET build.  Bug 3176
    
    Broken-by: 0cf5f1656eff

diff --git a/src/OS/Makefile-Base b/src/OS/Makefile-Base
index 25a8e82a7..40befe325 100644
--- a/src/OS/Makefile-Base
+++ b/src/OS/Makefile-Base
@@ -552,7 +552,8 @@ OBJ_LOOKUPS = lf_quote.o lf_check_file.o lf_sqlperform.o
 OBJ_ROUTERS = rf_change_domain.o rf_expand_data.o rf_get_errors_address.o \
 	rf_get_munge_headers.o rf_get_transport.o rf_get_ugid.o \
 	rf_lookup_hostlist.o rf_queue_add.o rf_self_action.o rf_set_ugid.o
-OBJ_AUTHS = check_serv_cond.o get_data.o get_no64_data.o pwcheck.o
+OBJ_AUTHS = call_saslauthd.o check_serv_cond.o \
+	get_data.o get_no64_data.o pwcheck.o
 
 OBJ_EXIM = acl.o atrn.o base64.o child.o crypt16.o daemon.o dbfn.o debug.o \
 	deliver.o directory.o dns.o drtables.o enq.o exim.o expand.o \
@@ -1002,6 +1003,9 @@ rf_set_ugid.o:           routers/rf_set_ugid.c
 auth-spa.o:         auths/auth-spa.c
 	@echo "$(CC) $<"
 	$(FE)$(CC) -c $(CFLAGS) -I. $(INCLUDE) $<
+call_saslauthd.o:  auths/call_saslauthd.c auths/pwcheck.h
+	@echo "$(CC) $<"
+	$(FE)$(CC) -c $(CFLAGS) -I. $(INCLUDE) $<
 check_serv_cond.o:  auths/check_serv_cond.c
 	@echo "$(CC) $<"
 	$(FE)$(CC) -c $(CFLAGS) -I. $(INCLUDE) $<
diff --git a/src/scripts/MakeLinks b/src/scripts/MakeLinks
index 765472195..4e4a638c7 100755
--- a/src/scripts/MakeLinks
+++ b/src/scripts/MakeLinks
@@ -78,7 +78,7 @@ d="auths"
 mkdir $d
 cd $d
 # Makefile is generated
-for f in README \
+for f in README call_saslauthd.c \
   check_serv_cond.c cyrus_sasl.c cyrus_sasl.h gsasl.c \
   gsasl.h get_data.c get_no64_data.c heimdal_gssapi.c heimdal_gssapi.h \
   cram_md5.c cram_md5.h plaintext.c plaintext.h \
diff --git a/src/src/auths/call_saslauthd.c b/src/src/auths/call_saslauthd.c
new file mode 100644
index 000000000..b5735fc6c
--- /dev/null
+++ b/src/src/auths/call_saslauthd.c
@@ -0,0 +1,69 @@
+/*************************************************
+*     Exim - an Internet mail transport agent    *
+*************************************************/
+
+/* Copyright (c) The Exim Maintainers 2020 - 2025 */
+/* Copyright (c) University of Cambridge 1995 - 2015 */
+/* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-or-later */
+
+/* This module contains interface functions to the two Cyrus authentication
+daemons. The original one was "pwcheck", which gives its name to the source
+file. This is now deprecated in favour of "saslauthd". */
+
+
+#include "../exim.h"
+#include "pwcheck.h"
+
+
+/*************************************************
+*       External entry point for saslauthd       *
+*************************************************/
+
+/* This function calls the "saslauthd" Cyrus-SASL authentication daemon,
+saslauthd, As this is called from the string expander, all the strings will
+always be in dynamic store and can be overwritten.
+
+Arguments:
+  username        username
+  password        password
+  service         optional service
+  realm           optional realm
+  errptr          where to point an error message
+
+Returns:   OK if authentication succeeded
+           FAIL if authentication failed
+           ERROR some other error condition
+*/
+
+int
+auth_call_saslauthd(const uschar *username, const uschar *password,
+  const uschar *service, const uschar *realm, uschar **errptr)
+{
+uschar *reply = NULL;
+
+if (service == NULL) service = US"";
+if (realm == NULL) realm = US"";
+
+DEBUG(D_auth)
+  debug_printf("Running saslauthd authentication for user %q \n", username);
+
+switch (saslauthd_verify_password(username, password, service,
+        realm, (const uschar **)(&reply)))
+  {
+  case PWCHECK_OK:
+  DEBUG(D_auth) debug_printf("saslauthd: success (%s)\n", reply);
+  return OK;
+
+  case PWCHECK_NO:
+  DEBUG(D_auth) debug_printf("saslauthd: access denied (%s)\n", reply);
+  return FAIL;
+
+  default:
+  DEBUG(D_auth) debug_printf("saslauthd: query failed (%s)\n", reply);
+  *errptr = reply;
+  return ERROR;
+  }
+}
+
+/* End of call_pwcheck.c */
diff --git a/src/src/expand.c b/src/src/expand.c
index fb32ce985..fcf699d2e 100644
--- a/src/src/expand.c
+++ b/src/src/expand.c
@@ -3712,14 +3712,10 @@ goto failout;
 
 /* A condition requires code that is not compiled */
 
-#if !defined(SUPPORT_PAM) || !defined(RADIUS_CONFIG_FILE) || \
-    !defined(LOOKUP_LDAP) || \
-    !defined(SUPPORT_CRYPTEQ) || !defined(CYRUS_SASLAUTHD_SOCKET)
 COND_FAILED_NOT_COMPILED:
 expand_string_message = string_sprintf("support for %q not compiled",
   opname);
 goto failout;
-#endif
 
 failout:
   next = NULL;

